/* Copyright (C) 2002, 2003, 2004, 2005 Jan Wedekind.
   This file is part of the recipe database application AnyMeal.

   AnyMeal is free software; you can redistribute it and/or modify it under
   the terms of the GNU GENERAL PUBLIC LICENSE as published by the Free
   Software Foundation; either version 2 of the License, or (at your option)
   any later version.

   AnyMeal is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTIBILITY or FITNESS
   FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with AnyMeal; if not, contact one of the authors of this software. */
#include "error.hpp"

/// Exception for indicating deprecated cookbook database.
class CookBookDeprecated: public Error
{
public:
  /** Constructor.
      @param _version Version of old recipe database version. */
  CookBookDeprecated( int _version ): version(_version) {}
  ///
  int getVersion(void) const { return version; }
protected:
  /// Version number of deprecated database.
  int version;
};
