#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './databaseWizard.ui'
**
** Created: Mo Okt 16 07:42:47 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.6   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "databaseWizard.h"

#include <qvariant.h>
#include <cassert>
#include <cstdlib>
#include <iostream>
#include <kfiledialog.h>
#include <klocale.h>
#include <kmessagebox.h>
#include <ktextbrowser.h>
#include <mysql/mysqld_error.h>
#include <sstream>
#include <errno.h>
#include <qpushbutton.h>
#include <qwidget.h>
#include <qgroupbox.h>
#include <kcombobox.h>
#include <qwidgetstack.h>
#include <klineedit.h>
#include <qlineedit.h>
#include <kpushbutton.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "ktextbrowser.h"
#include "kcombobox.h"
#include "klineedit.h"
#include "kpushbutton.h"
#include "displayWaitCursor.hpp"
#include "importMealMasterDialog.h"
#include "cookBook.hpp"
#include "cookBookDeprecated.hpp"
#include "error.hpp"
#include "mysqlDatabase.hpp"
#include "utils.hpp"
#include "./databaseWizard.ui.h"
/*
 *  Constructs a DatabaseWizard as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The wizard will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal wizard.
 */
DatabaseWizard::DatabaseWizard( QWidget* parent, const char* name, bool modal, WFlags fl )
    : KWizard( parent, name, modal, fl )
{
    if ( !name )
	setName( "DatabaseWizard" );
    setIcon( QPixmap::fromMimeSource( "dblogo.png" ) );

    welcomePage = new QWidget( this, "welcomePage" );
    welcomePageLayout = new QHBoxLayout( welcomePage, 11, 6, "welcomePageLayout"); 

    welcomeMessage = new KTextBrowser( welcomePage, "welcomeMessage" );
    welcomeMessage->setPaletteBackgroundColor( QColor( 220, 220, 220 ) );
    welcomeMessage->setWordWrap( KTextBrowser::WidgetWidth );
    welcomeMessage->setReadOnly( TRUE );
    welcomePageLayout->addWidget( welcomeMessage );
    addPage( welcomePage, QString("") );

    connectPage = new QWidget( this, "connectPage" );
    connectPageLayout = new QVBoxLayout( connectPage, 11, 6, "connectPageLayout"); 

    serverGroup = new QGroupBox( connectPage, "serverGroup" );
    serverGroup->setColumnLayout(0, Qt::Vertical );
    serverGroup->layout()->setSpacing( 6 );
    serverGroup->layout()->setMargin( 11 );
    serverGroupLayout = new QHBoxLayout( serverGroup->layout() );
    serverGroupLayout->setAlignment( Qt::AlignTop );

    serverTypeCombo = new KComboBox( FALSE, serverGroup, "serverTypeCombo" );
    serverGroupLayout->addWidget( serverTypeCombo );

    serverWidgetStack = new QWidgetStack( serverGroup, "serverWidgetStack" );
    serverWidgetStack->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, serverWidgetStack->sizePolicy().hasHeightForWidth() ) );

    WStackPage = new QWidget( serverWidgetStack, "WStackPage" );
    WStackPageLayout = new QHBoxLayout( WStackPage, 11, 6, "WStackPageLayout"); 

    serverEdit = new KLineEdit( WStackPage, "serverEdit" );
    WStackPageLayout->addWidget( serverEdit );
    serverWidgetStack->addWidget( WStackPage, 0 );

    WStackPage_2 = new QWidget( serverWidgetStack, "WStackPage_2" );
    WStackPageLayout_2 = new QGridLayout( WStackPage_2, 1, 1, 11, 6, "WStackPageLayout_2"); 

    socketEdit = new QLineEdit( WStackPage_2, "socketEdit" );

    WStackPageLayout_2->addWidget( socketEdit, 0, 0 );

    folderEdit = new KLineEdit( WStackPage_2, "folderEdit" );

    WStackPageLayout_2->addWidget( folderEdit, 1, 0 );

    selectSocketButton = new KPushButton( WStackPage_2, "selectSocketButton" );

    WStackPageLayout_2->addWidget( selectSocketButton, 0, 1 );

    selectFolderButton = new KPushButton( WStackPage_2, "selectFolderButton" );

    WStackPageLayout_2->addWidget( selectFolderButton, 1, 1 );
    serverWidgetStack->addWidget( WStackPage_2, 1 );
    serverGroupLayout->addWidget( serverWidgetStack );
    connectPageLayout->addWidget( serverGroup );

    rootUserGroup = new QGroupBox( connectPage, "rootUserGroup" );
    rootUserGroup->setColumnLayout(0, Qt::Vertical );
    rootUserGroup->layout()->setSpacing( 6 );
    rootUserGroup->layout()->setMargin( 11 );
    rootUserGroupLayout = new QGridLayout( rootUserGroup->layout() );
    rootUserGroupLayout->setAlignment( Qt::AlignTop );

    rootUserEdit = new KLineEdit( rootUserGroup, "rootUserEdit" );

    rootUserGroupLayout->addWidget( rootUserEdit, 0, 1 );

    rootUserLabel = new QLabel( rootUserGroup, "rootUserLabel" );

    rootUserGroupLayout->addWidget( rootUserLabel, 0, 0 );

    rootPassWordCheckBox = new QCheckBox( rootUserGroup, "rootPassWordCheckBox" );

    rootUserGroupLayout->addWidget( rootPassWordCheckBox, 1, 0 );

    rootPassWordEdit = new KLineEdit( rootUserGroup, "rootPassWordEdit" );
    rootPassWordEdit->setEnabled( FALSE );
    rootPassWordEdit->setEchoMode( KLineEdit::Password );

    rootUserGroupLayout->addWidget( rootPassWordEdit, 1, 1 );
    connectPageLayout->addWidget( rootUserGroup );
    spacer14 = new QSpacerItem( 21, 70, QSizePolicy::Minimum, QSizePolicy::Expanding );
    connectPageLayout->addItem( spacer14 );

    layout7 = new QHBoxLayout( 0, 0, 6, "layout7"); 
    spacer12 = new QSpacerItem( 100, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout7->addItem( spacer12 );

    connectButton = new KPushButton( connectPage, "connectButton" );
    layout7->addWidget( connectButton );
    spacer13 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout7->addItem( spacer13 );
    connectPageLayout->addLayout( layout7 );
    addPage( connectPage, QString("") );

    createDatabasePage = new QWidget( this, "createDatabasePage" );
    createDatabasePageLayout = new QVBoxLayout( createDatabasePage, 11, 6, "createDatabasePageLayout"); 

    databaseGroup = new QGroupBox( createDatabasePage, "databaseGroup" );
    databaseGroup->setColumnLayout(0, Qt::Vertical );
    databaseGroup->layout()->setSpacing( 6 );
    databaseGroup->layout()->setMargin( 11 );
    databaseGroupLayout = new QHBoxLayout( databaseGroup->layout() );
    databaseGroupLayout->setAlignment( Qt::AlignTop );

    databaseLabel = new QLabel( databaseGroup, "databaseLabel" );
    databaseGroupLayout->addWidget( databaseLabel );

    databaseEdit = new KLineEdit( databaseGroup, "databaseEdit" );
    databaseEdit->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, 0, 0, databaseEdit->sizePolicy().hasHeightForWidth() ) );
    databaseEdit->setMinimumSize( QSize( 0, 0 ) );
    databaseGroupLayout->addWidget( databaseEdit );
    createDatabasePageLayout->addWidget( databaseGroup );

    dataBaseInfoLabel = new QLabel( createDatabasePage, "dataBaseInfoLabel" );
    createDatabasePageLayout->addWidget( dataBaseInfoLabel );
    spacer17 = new QSpacerItem( 21, 310, QSizePolicy::Minimum, QSizePolicy::Expanding );
    createDatabasePageLayout->addItem( spacer17 );

    layout8 = new QHBoxLayout( 0, 0, 6, "layout8"); 
    spacer15 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout8->addItem( spacer15 );

    createDatabaseButton = new KPushButton( createDatabasePage, "createDatabaseButton" );
    layout8->addWidget( createDatabaseButton );
    spacer16 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout8->addItem( spacer16 );
    createDatabasePageLayout->addLayout( layout8 );
    addPage( createDatabasePage, QString("") );

    createUserPage = new QWidget( this, "createUserPage" );
    createUserPageLayout = new QVBoxLayout( createUserPage, 11, 6, "createUserPageLayout"); 

    databaseUserGroup = new QGroupBox( createUserPage, "databaseUserGroup" );
    databaseUserGroup->setColumnLayout(0, Qt::Vertical );
    databaseUserGroup->layout()->setSpacing( 6 );
    databaseUserGroup->layout()->setMargin( 11 );
    databaseUserGroupLayout = new QGridLayout( databaseUserGroup->layout() );
    databaseUserGroupLayout->setAlignment( Qt::AlignTop );

    clientLabel = new QLabel( databaseUserGroup, "clientLabel" );

    databaseUserGroupLayout->addWidget( clientLabel, 0, 0 );

    clientEdit = new KLineEdit( databaseUserGroup, "clientEdit" );

    databaseUserGroupLayout->addWidget( clientEdit, 0, 1 );

    databaseUserLabel = new QLabel( databaseUserGroup, "databaseUserLabel" );

    databaseUserGroupLayout->addWidget( databaseUserLabel, 1, 0 );

    databaseUserEdit = new KLineEdit( databaseUserGroup, "databaseUserEdit" );

    databaseUserGroupLayout->addWidget( databaseUserEdit, 1, 1 );

    databasePassWordCheckBox = new QCheckBox( databaseUserGroup, "databasePassWordCheckBox" );

    databaseUserGroupLayout->addWidget( databasePassWordCheckBox, 2, 0 );

    databasePassWordEdit = new KLineEdit( databaseUserGroup, "databasePassWordEdit" );
    databasePassWordEdit->setEnabled( FALSE );
    databasePassWordEdit->setEchoMode( KLineEdit::Password );

    databaseUserGroupLayout->addWidget( databasePassWordEdit, 2, 1 );

    databasePassWordConfirmEdit = new KLineEdit( databaseUserGroup, "databasePassWordConfirmEdit" );
    databasePassWordConfirmEdit->setEnabled( FALSE );
    databasePassWordConfirmEdit->setEchoMode( KLineEdit::Password );

    databaseUserGroupLayout->addWidget( databasePassWordConfirmEdit, 3, 1 );

    confirmLabel = new QLabel( databaseUserGroup, "confirmLabel" );

    databaseUserGroupLayout->addWidget( confirmLabel, 3, 0 );
    createUserPageLayout->addWidget( databaseUserGroup );

    databaseUserInfo = new QLabel( createUserPage, "databaseUserInfo" );
    databaseUserInfo->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );
    createUserPageLayout->addWidget( databaseUserInfo );
    spacer20_2 = new QSpacerItem( 21, 80, QSizePolicy::Minimum, QSizePolicy::Expanding );
    createUserPageLayout->addItem( spacer20_2 );

    layout9 = new QHBoxLayout( 0, 0, 6, "layout9"); 
    spacer18 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout9->addItem( spacer18 );

    createUserButton = new KPushButton( createUserPage, "createUserButton" );
    layout9->addWidget( createUserButton );
    spacer19 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout9->addItem( spacer19 );
    createUserPageLayout->addLayout( layout9 );
    addPage( createUserPage, QString("") );

    importRecipesPage = new QWidget( this, "importRecipesPage" );
    importRecipesPageLayout = new QVBoxLayout( importRecipesPage, 11, 6, "importRecipesPageLayout"); 

    importInfoBrowser = new KTextBrowser( importRecipesPage, "importInfoBrowser" );
    importInfoBrowser->setPaletteBackgroundColor( QColor( 220, 220, 220 ) );
    importRecipesPageLayout->addWidget( importInfoBrowser );

    layout25 = new QHBoxLayout( 0, 0, 6, "layout25"); 
    spacer43 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout25->addItem( spacer43 );

    importButton = new KPushButton( importRecipesPage, "importButton" );
    layout25->addWidget( importButton );
    spacer44 = new QSpacerItem( 101, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout25->addItem( spacer44 );
    importRecipesPageLayout->addLayout( layout25 );
    addPage( importRecipesPage, QString("") );
    languageChange();
    resize( QSize(652, 532).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( serverEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( connectButtonEnable() ) );
    connect( rootUserEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( connectButtonEnable() ) );
    connect( rootPassWordCheckBox, SIGNAL( toggled(bool) ), this, SLOT( connectButtonEnable() ) );
    connect( rootPassWordEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( connectButtonEnable() ) );
    connect( connectButton, SIGNAL( clicked() ), this, SLOT( connectToServer() ) );
    connect( rootPassWordCheckBox, SIGNAL( toggled(bool) ), rootPassWordEdit, SLOT( setEnabled(bool) ) );
    connect( databaseEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( createDatabaseEnable() ) );
    connect( createDatabaseButton, SIGNAL( clicked() ), this, SLOT( createDatabase() ) );
    connect( clientEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( createUserEnable() ) );
    connect( databaseUserEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( createUserEnable() ) );
    connect( databasePassWordCheckBox, SIGNAL( toggled(bool) ), databasePassWordEdit, SLOT( setEnabled(bool) ) );
    connect( databasePassWordEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( createUserEnable() ) );
    connect( createUserButton, SIGNAL( clicked() ), this, SLOT( createUser() ) );
    connect( databasePassWordCheckBox, SIGNAL( toggled(bool) ), this, SLOT( createUserEnable() ) );
    connect( databasePassWordCheckBox, SIGNAL( toggled(bool) ), databasePassWordConfirmEdit, SLOT( setEnabled(bool) ) );
    connect( databasePassWordConfirmEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( createUserEnable() ) );
    connect( importButton, SIGNAL( clicked() ), this, SLOT( importRecipes() ) );
    connect( serverTypeCombo, SIGNAL( activated(int) ), serverWidgetStack, SLOT( raiseWidget(int) ) );
    connect( selectSocketButton, SIGNAL( clicked() ), this, SLOT( selectSocket() ) );
    connect( serverTypeCombo, SIGNAL( activated(int) ), this, SLOT( connectButtonEnable() ) );
    connect( socketEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( socketChanged(const QString&) ) );

    // buddies
    rootUserLabel->setBuddy( rootUserEdit );
    databaseLabel->setBuddy( databaseEdit );
    clientLabel->setBuddy( clientEdit );
    databaseUserLabel->setBuddy( rootUserEdit );
    confirmLabel->setBuddy( databasePassWordConfirmEdit );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
DatabaseWizard::~DatabaseWizard()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void DatabaseWizard::languageChange()
{
    setCaption( tr2i18n( "Setup MySQL Datasource" ) );
    welcomeMessage->setText( tr2i18n( "<b>Welcome to AnyMeal</b>\n"
"<p><a href=\"http://anymeal.sourceforge.net\">AnyMeal</a> is a cookbook database front-end, which was developed with <i>C++</i>, <i>Qt</i>, <i>MySQL</i>, <i>Xalan-C</i>, <i>docbook</i> and other tools under <i>GNU/Linux</i>. It can handle more than 100,000 recipes and search recipes for a given set of ingredients! The software-design is lean and flexible.</p>\n"
"<p>This wizard allows you to do a step-by-step setup of a <i>MySQL</i> datasource. This involves setting up a database and an user-account. First you will connect to a running <i>MySQL</i>-server using an administrator-account of this database.</p>\n"
"<p>If you have problems using AnyMeal, refer to the webpage of <a href=\"http://www.wedesoft.demon.co.uk/anymeal-api/faq.html\">frequently asked questions</a>.</p>" ) );
    setTitle( welcomePage, tr2i18n( "Welcome" ) );
    serverGroup->setTitle( tr2i18n( "&Server" ) );
    serverTypeCombo->clear();
    serverTypeCombo->insertItem( tr2i18n( "Network" ) );
    serverTypeCombo->insertItem( tr2i18n( "Embedded" ) );
    serverTypeCombo->setCurrentItem( 1 );
    serverEdit->setText( tr2i18n( "localhost" ) );
    socketEdit->setText( tr2i18n( "~/.kde/share/apps/anymeal/db/mysql.sock" ) );
    folderEdit->setText( tr2i18n( "~/.kde/share/apps/anymeal/db" ) );
    selectSocketButton->setText( tr2i18n( "..." ) );
    selectFolderButton->setText( tr2i18n( "..." ) );
    rootUserGroup->setTitle( tr2i18n( "Database account for &administration" ) );
    rootUserEdit->setText( tr2i18n( "root" ) );
    rootUserLabel->setText( tr2i18n( "Na&me" ) );
    rootPassWordCheckBox->setText( tr2i18n( "Pass&word" ) );
    rootPassWordCheckBox->setAccel( QKeySequence( tr2i18n( "Alt+W" ) ) );
    connectButton->setText( tr2i18n( "Co&nnect" ) );
    connectButton->setAccel( QKeySequence( tr2i18n( "Alt+N" ) ) );
    setTitle( connectPage, tr2i18n( "Connect To Server" ) );
    databaseGroup->setTitle( tr2i18n( "Database" ) );
    databaseLabel->setText( tr2i18n( "&Name" ) );
    databaseEdit->setText( tr2i18n( "anymeal" ) );
    dataBaseInfoLabel->setText( tr2i18n( "You can also choose to connect to an existing recipe-database." ) );
    createDatabaseButton->setText( tr2i18n( "&Create/Connect" ) );
    createDatabaseButton->setAccel( QKeySequence( tr2i18n( "Alt+C" ) ) );
    setTitle( createDatabasePage, tr2i18n( "Create Database" ) );
    databaseUserGroup->setTitle( tr2i18n( "Database account for later &use" ) );
    clientLabel->setText( tr2i18n( "C&lient" ) );
    clientEdit->setText( tr2i18n( "localhost" ) );
    databaseUserLabel->setText( tr2i18n( "&Name" ) );
    databaseUserEdit->setText( tr2i18n( "anymeal" ) );
    databasePassWordCheckBox->setText( tr2i18n( "Pa&ssword" ) );
    databasePassWordCheckBox->setAccel( QKeySequence( tr2i18n( "Alt+S" ) ) );
    confirmLabel->setText( tr2i18n( "Con&firm" ) );
    databaseUserInfo->setText( tr2i18n( "You can also use an existing user-account, if you know the password." ) );
    createUserButton->setText( tr2i18n( "&Create/Use" ) );
    createUserButton->setAccel( QKeySequence( tr2i18n( "Alt+C" ) ) );
    setTitle( createUserPage, tr2i18n( "Create User" ) );
    importInfoBrowser->setText( tr2i18n( "You can import some recipes already, if you want to." ) );
    importButton->setText( tr2i18n( "&Import Recipes" ) );
    importButton->setAccel( QKeySequence( tr2i18n( "Alt+I" ) ) );
    setTitle( importRecipesPage, tr2i18n( "Import Recipes" ) );
}

#include "databaseWizard.moc"
