#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './recipeEditor.ui'
**
** Created: Mo Okt 16 07:43:51 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.6   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "recipeEditor.h"

#include <qvariant.h>
#include <cassert>
#include <sstream>
#include <qtextedit.h>
#include <qvalidator.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlabel.h>
#include <klineedit.h>
#include <qgroupbox.h>
#include <klistbox.h>
#include <kpushbutton.h>
#include <knuminput.h>
#include <qheader.h>
#include <qlistview.h>
#include <kcombobox.h>
#include <qwidgetstack.h>
#include <qsplitter.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "klineedit.h"
#include "kpushbutton.h"
#include "knuminput.h"
#include "kcombobox.h"
#include "ingredientViewItem.hpp"
#include "unitMap.hpp"
#include "utils.hpp"
#include "xmlDocument.hpp"
#include "xmlNodeReferenceList.hpp"
#include "./recipeEditor.ui.h"
/*
 *  Constructs a RecipeEditor as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
RecipeEditor::RecipeEditor( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "RecipeEditor" );
    setIcon( QPixmap::fromMimeSource( "editnew.png" ) );
    setSizeGripEnabled( TRUE );
    setModal( TRUE );
    RecipeEditorLayout = new QVBoxLayout( this, 11, 6, "RecipeEditorLayout"); 

    recipeTabs = new QTabWidget( this, "recipeTabs" );

    tab = new QWidget( recipeTabs, "tab" );
    tabLayout = new QVBoxLayout( tab, 11, 6, "tabLayout"); 

    layout3 = new QHBoxLayout( 0, 0, 6, "layout3"); 

    titleLabel = new QLabel( tab, "titleLabel" );
    layout3->addWidget( titleLabel );

    titleEdit = new KLineEdit( tab, "titleEdit" );
    titleEdit->setMaxLength( 100 );
    layout3->addWidget( titleEdit );
    tabLayout->addLayout( layout3 );

    categoriesGroupBox = new QGroupBox( tab, "categoriesGroupBox" );
    categoriesGroupBox->setColumnLayout(0, Qt::Vertical );
    categoriesGroupBox->layout()->setSpacing( 6 );
    categoriesGroupBox->layout()->setMargin( 11 );
    categoriesGroupBoxLayout = new QVBoxLayout( categoriesGroupBox->layout() );
    categoriesGroupBoxLayout->setAlignment( Qt::AlignTop );

    layout14 = new QHBoxLayout( 0, 0, 6, "layout14"); 

    categoriesListBox = new KListBox( categoriesGroupBox, "categoriesListBox" );
    categoriesListBox->setFocusPolicy( KListBox::NoFocus );
    layout14->addWidget( categoriesListBox );

    layout13 = new QVBoxLayout( 0, 0, 6, "layout13"); 
    spacer7 = new QSpacerItem( 20, 186, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout13->addItem( spacer7 );

    categoryAddButton = new KPushButton( categoriesGroupBox, "categoryAddButton" );
    layout13->addWidget( categoryAddButton );

    categoryRemoveButton = new KPushButton( categoriesGroupBox, "categoryRemoveButton" );
    categoryRemoveButton->setEnabled( FALSE );
    layout13->addWidget( categoryRemoveButton );

    categoryUpButton = new KPushButton( categoriesGroupBox, "categoryUpButton" );
    categoryUpButton->setEnabled( FALSE );
    categoryUpButton->setPixmap( QPixmap::fromMimeSource( "uparrow.png" ) );
    layout13->addWidget( categoryUpButton );

    categoryDownButton = new KPushButton( categoriesGroupBox, "categoryDownButton" );
    categoryDownButton->setEnabled( FALSE );
    categoryDownButton->setPixmap( QPixmap::fromMimeSource( "downarrow.png" ) );
    layout13->addWidget( categoryDownButton );
    spacer8 = new QSpacerItem( 20, 186, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout13->addItem( spacer8 );
    layout14->addLayout( layout13 );
    categoriesGroupBoxLayout->addLayout( layout14 );

    layout8 = new QHBoxLayout( 0, 0, 6, "layout8"); 

    textLabel1 = new QLabel( categoriesGroupBox, "textLabel1" );
    layout8->addWidget( textLabel1 );

    categoryEdit = new KLineEdit( categoriesGroupBox, "categoryEdit" );
    categoryEdit->setEnabled( FALSE );
    categoryEdit->setMaxLength( 100 );
    layout8->addWidget( categoryEdit );
    categoriesGroupBoxLayout->addLayout( layout8 );
    tabLayout->addWidget( categoriesGroupBox );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    servingsLabel = new QLabel( tab, "servingsLabel" );
    layout2->addWidget( servingsLabel );

    servingsSpinBox = new KIntSpinBox( tab, "servingsSpinBox" );
    servingsSpinBox->setMaxValue( 9999 );
    servingsSpinBox->setMinValue( 1 );
    layout2->addWidget( servingsSpinBox );

    servingsEdit = new KLineEdit( tab, "servingsEdit" );
    servingsEdit->setMaxLength( 10 );
    layout2->addWidget( servingsEdit );
    tabLayout->addLayout( layout2 );
    recipeTabs->insertTab( tab, QString::fromLatin1("") );

    tab_2 = new QWidget( recipeTabs, "tab_2" );
    tabLayout_2 = new QVBoxLayout( tab_2, 11, 6, "tabLayout_2"); 

    ingredientsGroup = new QGroupBox( tab_2, "ingredientsGroup" );
    ingredientsGroup->setColumnLayout(0, Qt::Vertical );
    ingredientsGroup->layout()->setSpacing( 6 );
    ingredientsGroup->layout()->setMargin( 11 );
    ingredientsGroupLayout = new QVBoxLayout( ingredientsGroup->layout() );
    ingredientsGroupLayout->setAlignment( Qt::AlignTop );

    layout16 = new QHBoxLayout( 0, 0, 6, "layout16"); 

    ingredientsView = new QListView( ingredientsGroup, "ingredientsView" );
    ingredientsView->addColumn( tr2i18n( "Amount" ) );
    ingredientsView->addColumn( tr2i18n( "Unit" ) );
    ingredientsView->addColumn( tr2i18n( "Name" ) );
    ingredientsView->addColumn( tr2i18n( "Preparation" ) );
    ingredientsView->setAllColumnsShowFocus( TRUE );
    ingredientsView->setRootIsDecorated( TRUE );
    ingredientsView->setResizeMode( QListView::LastColumn );
    layout16->addWidget( ingredientsView );

    layout15 = new QVBoxLayout( 0, 0, 6, "layout15"); 
    spacer7_2 = new QSpacerItem( 20, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout15->addItem( spacer7_2 );

    addIngredientsGroupButton = new KPushButton( ingredientsGroup, "addIngredientsGroupButton" );
    layout15->addWidget( addIngredientsGroupButton );

    addIngredientButton = new KPushButton( ingredientsGroup, "addIngredientButton" );
    addIngredientButton->setEnabled( FALSE );
    layout15->addWidget( addIngredientButton );

    removeIngredientButton = new KPushButton( ingredientsGroup, "removeIngredientButton" );
    removeIngredientButton->setEnabled( FALSE );
    layout15->addWidget( removeIngredientButton );

    ingredientsUpButton = new KPushButton( ingredientsGroup, "ingredientsUpButton" );
    ingredientsUpButton->setEnabled( FALSE );
    ingredientsUpButton->setPixmap( QPixmap::fromMimeSource( "uparrow.png" ) );
    layout15->addWidget( ingredientsUpButton );

    ingredientsDownButton = new KPushButton( ingredientsGroup, "ingredientsDownButton" );
    ingredientsDownButton->setEnabled( FALSE );
    ingredientsDownButton->setPixmap( QPixmap::fromMimeSource( "downarrow.png" ) );
    layout15->addWidget( ingredientsDownButton );
    spacer8_2 = new QSpacerItem( 20, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout15->addItem( spacer8_2 );
    layout16->addLayout( layout15 );
    ingredientsGroupLayout->addLayout( layout16 );

    layout17 = new QHBoxLayout( 0, 0, 6, "layout17"); 

    ingredientsGroupLabel = new QLabel( ingredientsGroup, "ingredientsGroupLabel" );
    layout17->addWidget( ingredientsGroupLabel );

    ingredientsGroupEdit = new KLineEdit( ingredientsGroup, "ingredientsGroupEdit" );
    ingredientsGroupEdit->setEnabled( FALSE );
    ingredientsGroupEdit->setMaxLength( 100 );
    layout17->addWidget( ingredientsGroupEdit );
    ingredientsGroupLayout->addLayout( layout17 );

    ingredientGroupBox = new QGroupBox( ingredientsGroup, "ingredientGroupBox" );
    ingredientGroupBox->setColumnLayout(0, Qt::Vertical );
    ingredientGroupBox->layout()->setSpacing( 6 );
    ingredientGroupBox->layout()->setMargin( 11 );
    ingredientGroupBoxLayout = new QGridLayout( ingredientGroupBox->layout() );
    ingredientGroupBoxLayout->setAlignment( Qt::AlignTop );

    prepEdit = new KLineEdit( ingredientGroupBox, "prepEdit" );
    prepEdit->setEnabled( FALSE );

    ingredientGroupBoxLayout->addWidget( prepEdit, 3, 1 );

    nameEdit = new KLineEdit( ingredientGroupBox, "nameEdit" );
    nameEdit->setEnabled( FALSE );
    nameEdit->setMaxLength( 100 );

    ingredientGroupBoxLayout->addWidget( nameEdit, 2, 1 );

    prepLabel = new QLabel( ingredientGroupBox, "prepLabel" );

    ingredientGroupBoxLayout->addWidget( prepLabel, 3, 0 );

    amountLabel = new QLabel( ingredientGroupBox, "amountLabel" );

    ingredientGroupBoxLayout->addWidget( amountLabel, 0, 0 );

    nameLabel = new QLabel( ingredientGroupBox, "nameLabel" );

    ingredientGroupBoxLayout->addWidget( nameLabel, 2, 0 );

    layout13_2 = new QHBoxLayout( 0, 0, 6, "layout13_2"); 

    amountTypeCombo = new KComboBox( FALSE, ingredientGroupBox, "amountTypeCombo" );
    amountTypeCombo->setEnabled( FALSE );
    layout13_2->addWidget( amountTypeCombo );

    amountWidgetStack = new QWidgetStack( ingredientGroupBox, "amountWidgetStack" );

    WStackPage = new QWidget( amountWidgetStack, "WStackPage" );
    WStackPageLayout = new QHBoxLayout( WStackPage, 11, 6, "WStackPageLayout"); 

    amountEdit = new KLineEdit( WStackPage, "amountEdit" );
    amountEdit->setEnabled( FALSE );
    WStackPageLayout->addWidget( amountEdit );
    amountWidgetStack->addWidget( WStackPage, 0 );

    WStackPage_2 = new QWidget( amountWidgetStack, "WStackPage_2" );
    WStackPageLayout_2 = new QHBoxLayout( WStackPage_2, 11, 6, "WStackPageLayout_2"); 

    naturalNumSpinBox = new KIntSpinBox( WStackPage_2, "naturalNumSpinBox" );
    naturalNumSpinBox->setMaxValue( 9999999 );
    WStackPageLayout_2->addWidget( naturalNumSpinBox );

    plusLabel = new QLabel( WStackPage_2, "plusLabel" );
    WStackPageLayout_2->addWidget( plusLabel );

    nominatorSpinBox = new KIntSpinBox( WStackPage_2, "nominatorSpinBox" );
    nominatorSpinBox->setMaxValue( 999 );
    WStackPageLayout_2->addWidget( nominatorSpinBox );

    divLabel = new QLabel( WStackPage_2, "divLabel" );
    WStackPageLayout_2->addWidget( divLabel );

    denominatorSpinBox = new KIntSpinBox( WStackPage_2, "denominatorSpinBox" );
    denominatorSpinBox->setMaxValue( 1000 );
    denominatorSpinBox->setMinValue( 1 );
    WStackPageLayout_2->addWidget( denominatorSpinBox );
    amountWidgetStack->addWidget( WStackPage_2, 1 );
    layout13_2->addWidget( amountWidgetStack );

    ingredientGroupBoxLayout->addLayout( layout13_2, 0, 1 );

    unitComboBox = new KComboBox( FALSE, ingredientGroupBox, "unitComboBox" );
    unitComboBox->setEnabled( FALSE );
    unitComboBox->setEditable( TRUE );

    ingredientGroupBoxLayout->addWidget( unitComboBox, 1, 1 );

    unitLabel = new QLabel( ingredientGroupBox, "unitLabel" );

    ingredientGroupBoxLayout->addWidget( unitLabel, 1, 0 );
    ingredientsGroupLayout->addWidget( ingredientGroupBox );
    tabLayout_2->addWidget( ingredientsGroup );
    recipeTabs->insertTab( tab_2, QString::fromLatin1("") );

    TabPage = new QWidget( recipeTabs, "TabPage" );
    TabPageLayout = new QVBoxLayout( TabPage, 11, 6, "TabPageLayout"); 

    splitter3 = new QSplitter( TabPage, "splitter3" );
    splitter3->setOrientation( QSplitter::Vertical );

    instructionsGroupGroupBox = new QGroupBox( splitter3, "instructionsGroupGroupBox" );
    instructionsGroupGroupBox->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)7, 0, 1, instructionsGroupGroupBox->sizePolicy().hasHeightForWidth() ) );
    instructionsGroupGroupBox->setColumnLayout(0, Qt::Vertical );
    instructionsGroupGroupBox->layout()->setSpacing( 6 );
    instructionsGroupGroupBox->layout()->setMargin( 11 );
    instructionsGroupGroupBoxLayout = new QVBoxLayout( instructionsGroupGroupBox->layout() );
    instructionsGroupGroupBoxLayout->setAlignment( Qt::AlignTop );

    layout12 = new QHBoxLayout( 0, 0, 6, "layout12"); 

    instructionsGroupListBox = new KListBox( instructionsGroupGroupBox, "instructionsGroupListBox" );
    layout12->addWidget( instructionsGroupListBox );

    layout11 = new QVBoxLayout( 0, 0, 6, "layout11"); 
    spacer8_3 = new QSpacerItem( 20, 21, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout11->addItem( spacer8_3 );

    instructionsGroupAddButton = new KPushButton( instructionsGroupGroupBox, "instructionsGroupAddButton" );
    layout11->addWidget( instructionsGroupAddButton );

    instructionsGroupRemoveButton = new KPushButton( instructionsGroupGroupBox, "instructionsGroupRemoveButton" );
    instructionsGroupRemoveButton->setEnabled( FALSE );
    layout11->addWidget( instructionsGroupRemoveButton );

    instructionsGroupUpButton = new KPushButton( instructionsGroupGroupBox, "instructionsGroupUpButton" );
    instructionsGroupUpButton->setEnabled( FALSE );
    instructionsGroupUpButton->setPixmap( QPixmap::fromMimeSource( "uparrow.png" ) );
    layout11->addWidget( instructionsGroupUpButton );

    instructionsGroupDownButton = new KPushButton( instructionsGroupGroupBox, "instructionsGroupDownButton" );
    instructionsGroupDownButton->setEnabled( FALSE );
    instructionsGroupDownButton->setPixmap( QPixmap::fromMimeSource( "downarrow.png" ) );
    layout11->addWidget( instructionsGroupDownButton );
    spacer9 = new QSpacerItem( 20, 21, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout11->addItem( spacer9 );
    layout12->addLayout( layout11 );
    instructionsGroupGroupBoxLayout->addLayout( layout12 );

    layout13_3 = new QHBoxLayout( 0, 0, 6, "layout13_3"); 

    instructionsGroupLabel = new QLabel( instructionsGroupGroupBox, "instructionsGroupLabel" );
    layout13_3->addWidget( instructionsGroupLabel );

    instructionsGroupEdit = new KLineEdit( instructionsGroupGroupBox, "instructionsGroupEdit" );
    instructionsGroupEdit->setEnabled( FALSE );
    instructionsGroupEdit->setMaxLength( 100 );
    layout13_3->addWidget( instructionsGroupEdit );
    instructionsGroupGroupBoxLayout->addLayout( layout13_3 );

    instructionsGroupBox = new QGroupBox( splitter3, "instructionsGroupBox" );
    instructionsGroupBox->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)7, 0, 3, instructionsGroupBox->sizePolicy().hasHeightForWidth() ) );
    instructionsGroupBox->setColumnLayout(0, Qt::Vertical );
    instructionsGroupBox->layout()->setSpacing( 6 );
    instructionsGroupBox->layout()->setMargin( 11 );
    instructionsGroupBoxLayout = new QVBoxLayout( instructionsGroupBox->layout() );
    instructionsGroupBoxLayout->setAlignment( Qt::AlignTop );

    instructionsWidgetStack = new QWidgetStack( instructionsGroupBox, "instructionsWidgetStack" );
    instructionsWidgetStack->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)7, 0, 0, instructionsWidgetStack->sizePolicy().hasHeightForWidth() ) );

    dummy = new QWidget( instructionsWidgetStack, "dummy" );
    instructionsWidgetStack->addWidget( dummy, 0 );
    instructionsGroupBoxLayout->addWidget( instructionsWidgetStack );
    TabPageLayout->addWidget( splitter3 );
    recipeTabs->insertTab( TabPage, QString::fromLatin1("") );
    RecipeEditorLayout->addWidget( recipeTabs );

    layout1 = new QHBoxLayout( 0, 0, 6, "layout1"); 
    spacer1 = new QSpacerItem( 25, 41, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer1 );

    okButton = new KPushButton( this, "okButton" );
    okButton->setEnabled( FALSE );
    okButton->setDefault( TRUE );
    layout1->addWidget( okButton );
    spacer2 = new QSpacerItem( 50, 31, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer2 );

    cancelButton = new KPushButton( this, "cancelButton" );
    layout1->addWidget( cancelButton );
    spacer3 = new QSpacerItem( 25, 31, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer3 );
    RecipeEditorLayout->addLayout( layout1 );
    languageChange();
    resize( QSize(598, 721).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( addIngredientButton, SIGNAL( clicked() ), this, SLOT( addIngredient() ) );
    connect( addIngredientsGroupButton, SIGNAL( clicked() ), this, SLOT( addIngredientsGroup() ) );
    connect( cancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( categoriesListBox, SIGNAL( highlighted(int) ), this, SLOT( categorySelected(int) ) );
    connect( categoryAddButton, SIGNAL( clicked() ), this, SLOT( addCategory() ) );
    connect( categoryDownButton, SIGNAL( clicked() ), this, SLOT( categoryDown() ) );
    connect( categoryEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( categoryText(const QString&) ) );
    connect( categoryRemoveButton, SIGNAL( clicked() ), this, SLOT( deleteCategory() ) );
    connect( categoryUpButton, SIGNAL( clicked() ), this, SLOT( categoryUp() ) );
    connect( ingredientsGroupEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( ingredientsGroupText(const QString&) ) );
    connect( ingredientsView, SIGNAL( currentChanged(QListViewItem*) ), this, SLOT( ingredientSelected(QListViewItem*) ) );
    connect( instructionsGroupAddButton, SIGNAL( clicked() ), this, SLOT( addInstructions() ) );
    connect( instructionsGroupListBox, SIGNAL( highlighted(int) ), this, SLOT( instructionSelected(int) ) );
    connect( instructionsGroupRemoveButton, SIGNAL( clicked() ), this, SLOT( deleteInstructions() ) );
    connect( nameEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( nameTextChanged(const QString&) ) );
    connect( okButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( removeIngredientButton, SIGNAL( clicked() ), this, SLOT( deleteIngredient() ) );
    connect( titleEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( updateOkEnabled() ) );
    connect( amountEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( amountTextChanged(const QString&) ) );
    connect( unitComboBox, SIGNAL( activated(const QString&) ), this, SLOT( unitTextChanged(const QString&) ) );
    connect( prepEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( preparationTextChanged(const QString&) ) );
    connect( instructionsGroupEdit, SIGNAL( textChanged(const QString&) ), this, SLOT( instructionsGroupText(const QString&) ) );
    connect( ingredientsUpButton, SIGNAL( clicked() ), this, SLOT( ingredientUp() ) );
    connect( ingredientsDownButton, SIGNAL( clicked() ), this, SLOT( ingredientDown() ) );
    connect( instructionsGroupUpButton, SIGNAL( clicked() ), this, SLOT( instructionsUp() ) );
    connect( instructionsGroupDownButton, SIGNAL( clicked() ), this, SLOT( instructionsDown() ) );
    connect( unitComboBox, SIGNAL( textChanged(const QString&) ), this, SLOT( unitTextChanged(const QString&) ) );
    connect( amountTypeCombo, SIGNAL( activated(int) ), this, SLOT( setAmountType(int) ) );
    connect( naturalNumSpinBox, SIGNAL( valueChanged(int) ), this, SLOT( amountNumberChanged(int) ) );
    connect( nominatorSpinBox, SIGNAL( valueChanged(int) ), this, SLOT( amountNominatorChanged(int) ) );
    connect( denominatorSpinBox, SIGNAL( valueChanged(int) ), this, SLOT( amountDenominatorChanged(int) ) );

    // tab order
    setTabOrder( recipeTabs, instructionsGroupListBox );
    setTabOrder( instructionsGroupListBox, instructionsGroupAddButton );
    setTabOrder( instructionsGroupAddButton, instructionsGroupRemoveButton );
    setTabOrder( instructionsGroupRemoveButton, instructionsGroupUpButton );
    setTabOrder( instructionsGroupUpButton, instructionsGroupDownButton );
    setTabOrder( instructionsGroupDownButton, instructionsGroupEdit );
    setTabOrder( instructionsGroupEdit, ingredientsView );
    setTabOrder( ingredientsView, addIngredientsGroupButton );
    setTabOrder( addIngredientsGroupButton, addIngredientButton );
    setTabOrder( addIngredientButton, removeIngredientButton );
    setTabOrder( removeIngredientButton, ingredientsUpButton );
    setTabOrder( ingredientsUpButton, ingredientsDownButton );
    setTabOrder( ingredientsDownButton, ingredientsGroupEdit );
    setTabOrder( ingredientsGroupEdit, amountTypeCombo );
    setTabOrder( amountTypeCombo, unitComboBox );
    setTabOrder( unitComboBox, nameEdit );
    setTabOrder( nameEdit, prepEdit );
    setTabOrder( prepEdit, amountEdit );
    setTabOrder( amountEdit, titleEdit );
    setTabOrder( titleEdit, categoryAddButton );
    setTabOrder( categoryAddButton, categoryRemoveButton );
    setTabOrder( categoryRemoveButton, categoryUpButton );
    setTabOrder( categoryUpButton, categoryDownButton );
    setTabOrder( categoryDownButton, categoryEdit );
    setTabOrder( categoryEdit, servingsSpinBox );
    setTabOrder( servingsSpinBox, servingsEdit );
    setTabOrder( servingsEdit, okButton );
    setTabOrder( okButton, cancelButton );
    setTabOrder( cancelButton, categoriesListBox );

    // buddies
    titleLabel->setBuddy( titleEdit );
    textLabel1->setBuddy( categoryEdit );
    servingsLabel->setBuddy( servingsSpinBox );
    ingredientsGroupLabel->setBuddy( ingredientsGroupEdit );
    prepLabel->setBuddy( prepEdit );
    amountLabel->setBuddy( amountEdit );
    nameLabel->setBuddy( nameEdit );
    unitLabel->setBuddy( unitComboBox );
    instructionsGroupLabel->setBuddy( instructionsGroupEdit );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
RecipeEditor::~RecipeEditor()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void RecipeEditor::languageChange()
{
    setCaption( tr2i18n( "Edit Recipe" ) );
    titleLabel->setText( tr2i18n( "&Title:" ) );
    categoriesGroupBox->setTitle( tr2i18n( "Categories" ) );
    categoryAddButton->setText( tr2i18n( "&Add" ) );
    categoryAddButton->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    categoryRemoveButton->setText( tr2i18n( "&Remove" ) );
    categoryRemoveButton->setAccel( QKeySequence( tr2i18n( "Alt+R" ) ) );
    categoryUpButton->setText( QString::null );
    categoryDownButton->setText( QString::null );
    textLabel1->setText( tr2i18n( "&Category:" ) );
    servingsLabel->setText( tr2i18n( "&Servings:" ) );
    recipeTabs->changeTab( tab, tr2i18n( "&General" ) );
    ingredientsGroup->setTitle( tr2i18n( "Ingredients" ) );
    ingredientsView->header()->setLabel( 0, tr2i18n( "Amount" ) );
    ingredientsView->header()->setLabel( 1, tr2i18n( "Unit" ) );
    ingredientsView->header()->setLabel( 2, tr2i18n( "Name" ) );
    ingredientsView->header()->setLabel( 3, tr2i18n( "Preparation" ) );
    addIngredientsGroupButton->setText( tr2i18n( "Add &Group" ) );
    addIngredientsGroupButton->setAccel( QKeySequence( tr2i18n( "Alt+G" ) ) );
    addIngredientButton->setText( tr2i18n( "Add I&ngredient" ) );
    addIngredientButton->setAccel( QKeySequence( tr2i18n( "Alt+N" ) ) );
    removeIngredientButton->setText( tr2i18n( "&Remove" ) );
    removeIngredientButton->setAccel( QKeySequence( tr2i18n( "Alt+R" ) ) );
    ingredientsUpButton->setText( QString::null );
    ingredientsDownButton->setText( QString::null );
    ingredientsGroupLabel->setText( tr2i18n( "&Group:" ) );
    ingredientGroupBox->setTitle( tr2i18n( "Ingredient" ) );
    prepEdit->setText( QString::null );
    prepLabel->setText( tr2i18n( "&Preparation:" ) );
    amountLabel->setText( tr2i18n( "&Amount:" ) );
    nameLabel->setText( tr2i18n( "&Name:" ) );
    amountTypeCombo->clear();
    amountTypeCombo->insertItem( tr2i18n( "floating point" ) );
    amountTypeCombo->insertItem( tr2i18n( "fraction" ) );
    plusLabel->setText( tr2i18n( "+" ) );
    divLabel->setText( tr2i18n( "/" ) );
    unitLabel->setText( tr2i18n( "&Unit:" ) );
    recipeTabs->changeTab( tab_2, tr2i18n( "&Ingredients" ) );
    instructionsGroupGroupBox->setTitle( tr2i18n( "Groups" ) );
    instructionsGroupAddButton->setText( tr2i18n( "&Add" ) );
    instructionsGroupAddButton->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    instructionsGroupRemoveButton->setText( tr2i18n( "&Remove" ) );
    instructionsGroupRemoveButton->setAccel( QKeySequence( tr2i18n( "Alt+R" ) ) );
    instructionsGroupUpButton->setText( QString::null );
    instructionsGroupDownButton->setText( QString::null );
    instructionsGroupLabel->setText( tr2i18n( "Gr&oup:" ) );
    instructionsGroupBox->setTitle( tr2i18n( "Instructions" ) );
    recipeTabs->changeTab( TabPage, tr2i18n( "I&nstructions" ) );
    okButton->setText( tr2i18n( "&Ok" ) );
    okButton->setAccel( QKeySequence( tr2i18n( "Alt+O" ) ) );
    cancelButton->setText( tr2i18n( "&Cancel" ) );
    cancelButton->setAccel( QKeySequence( tr2i18n( "Alt+C" ) ) );
}

#include "recipeEditor.moc"
