/* Copyright (C) 2002, 2003, 2004, 2005 Jan Wedekind.
   This file is part of the recipe database application AnyMeal.

   AnyMeal is free software; you can redistribute it and/or modify it under
   the terms of the GNU GENERAL PUBLIC LICENSE as published by the Free
   Software Foundation; either version 2 of the License, or (at your option)
   any later version.

   AnyMeal is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTIBILITY or FITNESS
   FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with AnyMeal; if not, contact one of the authors of this software. */
#ifndef __RECIPELISTITEM_HPP
#define __RECIPELISTITEM_HPP

#include <qlistview.h>
#include <set>

/** Item for displaying a recipe.
    @date Wed Mar 09 2005
    @author Jan Wedekind (wedesoft@users.sourceforge.net) */
class RecipeListItem: public QCheckListItem
{
 public:
  ///
  typedef QCheckListItem::Type Type;
  ///
  RecipeListItem( QListView *parent, int _id, const QString &_title,
                  bool _selected );
  ///
  virtual int compare( QListViewItem *i, int col, bool ascending ) const;
  ///
  void setId( int _id );
  ///
  void setTitle( const QString &_title );
  ///
  int getId(void) const { return id; }
protected:
  ///
  int id;
};

#endif
